#include "stdafx.h"

#include "FrameImage.h"

CreateFrameOperation<FrameImage, &FrameImage::readFrom> g_createFrameImage("FrameImage");

const std::string& FrameImage::fileName() const
{
	return m_fileName;
}

bool FrameImage::usesFrame(LONG frame) const
{
	return false;
}

FrameImage::FrameImage(CVclipDoc& owner, 
	LONG targetFrame /*= 0*/, const std::string& fileName /*= std::string()*/)
	: FrameOperation(owner, targetFrame), m_fileName(fileName)
{
}

const char* FrameImage::typeCode() const
{
	return "FrameImage";
}

void FrameImage::writeTo(std::ostream& stream) const
{
	stream << targetFrame() << " " << m_fileName;
}

void FrameImage::readFrom(std::istream& stream)
{
	LONG targetFrame;
	stream >> targetFrame >> m_fileName;
	setTargetFrame(targetFrame);
}

void FrameImage::accept(IOperationVisitor& visitor)
{
	visitor(*this);
}
