#pragma once

#include <afxwin.h>
#include "vclipDoc.h"
#include "FrameCache.h"

class FrameRenderer
{
private:
	CDC* m_pDC;
	CVclipDoc* m_document;
	const AviFile* m_aviFile;
	const ImageCache* m_images;
	bool m_evenCoords;

public:
	FrameRenderer(CDC* pDC, CVclipDoc& document, const AviFile& aviFile, 
		const ImageCache& images, bool evenCoords);

	PFrame render(LONG frameNumber) const;
	PFrame render(LONG frameNumber, CVclipDoc::iterator end) const;
	PFrame renderDirectly(LONG frameNumber, CVclipDoc::iterator end) const;
	PFrame renderViaAvisynth(LONG frameNumber, CVclipDoc::iterator end) const;

	bool canRenderDirectly(LONG frameNumber, CVclipDoc::iterator end) const;
};
