#include "stdafx.h"

#include "MotionInterpolate.h"

CreateFrameOperation<MotionInterpolate, &MotionInterpolate::readMotionInterpolate> g_createMotionInterpolate("MotionInterpolate");
CreateFrameOperation<MotionInterpolate, &MotionInterpolate::readMotionInterpolate2> g_createMotionInterpolate2("MotionInterpolate2");

MotionInterpolate::MotionInterpolate(CVclipDoc& owner, LONG targetFrame /*= 0*/, 
	int targetX /*= 0*/, int targetY /*= 0*/, int targetWidth /*= 0*/, int targetHeight /*= 0*/)
: PatchOperation(owner, targetFrame, targetX, targetY, targetWidth, targetHeight)
{
}

bool MotionInterpolate::usesFrame(LONG frame) const
{
	return false;
}

const char* MotionInterpolate::typeCode() const
{
	return "MotionInterpolate2";
}

void MotionInterpolate::writeTo(std::ostream& stream) const
{
	stream << targetFrame() << " " <<
		targetX() << " " <<
		targetY() << " " <<
		targetWidth() << " " <<
		targetHeight();
}

void MotionInterpolate::readMotionInterpolate(std::istream& stream)
{
	LONG targetFrame;
	stream >> targetFrame;
	setTargetFrame(targetFrame);
	setTargetRect(CRect(0, 0, -1, -1));
}

void MotionInterpolate::readMotionInterpolate2(std::istream& stream)
{
	LONG targetFrame;
	CPoint targetOrigin;
	CSize targetSize;
	stream >> targetFrame >>
		targetOrigin.x >>
		targetOrigin.y >>
		targetSize.cx >>
		targetSize.cy;
	setTargetFrame(targetFrame);
	setTargetRect(CRect(targetOrigin, targetSize));
}

void MotionInterpolate::accept(IOperationVisitor& visitor)
{
	visitor(*this);
}
