#include "stdafx.h"
#include "OverlayMode.h"

#include "exception.h"

Overlays& Overlays::instance()
{
	static Overlays s_instance;
	return s_instance;
}

void Overlays::insert(const char* name, HOverlay overlay)
{
	m_overlays.insert(std::make_pair(name, overlay));
}

HOverlay Overlays::operator[](const std::string& name) const
{
	return ASSERT_NE(m_overlays.find(name), m_overlays.end(), "invalid overlay mode")->second;
}

Overlays::Register<OpaqueOverlay> g_opaqueOverlay("Blend");
Overlays::Register<ChromaOverlay> g_chromaOverlay("Chroma");
Overlays::Register<LumaOverlay>   g_lumaOverlay("Luma");

std::istream& operator>>(std::istream& stream, HOverlay& pOverlay)
{
	std::string keyword;
	stream >> keyword;
	pOverlay = (!stream || keyword.empty()) ? &g_opaqueOverlay : Overlays::instance()[keyword];
	return stream;
}

std::ostream& operator<<(std::ostream& stream, HOverlay pOverlay)
{
	return stream << pOverlay->typeCode();
}

