#ifndef YK_ADAPTERS_H
#define YK_ADAPTERS_H

#include <functional>
#include <iterator>

namespace yk
{
	template <typename T, class C>
	class data_member_t : public std::unary_function<C, T>
	{
	public:
		explicit data_member_t(T C::* member)
		: member_(member)
		{}

		const T& operator()(const C& object) const
		{
			return object.*member_;
		}
  	private:
		T C::* member_;
  	};

	template <typename T, class C>
	data_member_t<T, C>
	data_member(T C::* member)
	{
		return data_member_t<T, C>(member);
	}

	template <typename Iterator>
	class dereference: public std::unary_function<Iterator,
		typename std::iterator_traits<Iterator>::reference>
	{
	public:
		typename std::iterator_traits<Iterator>::reference operator()(const Iterator& it) const
		{
			return *it;
		}
	};
}

#endif
